package tp03.ex02;

import java.time.LocalDate;

public class UseTask {

	public static void main (String[] args) {
		Task t1 = new Task("Finir exo1", 1);
		Task t2 = new Task("Finir exo2", LocalDate.of(2025, 02, 01), LocalDate.of(2025, 03, 01), 2);

		System.out.println(t1);
		System.out.println(t2);

		t1.changeStatus();
		t2.changeStatus(TaskStatus.FINISHED);

		System.out.println(t1);
		System.out.println(t2);

		// Test of isLate()
		Task t3 = new Task("Finir exo3", LocalDate.of(2025, 02, 01), LocalDate.of(2025, 02, 10), 5);
		Task t4 = new Task("Finir exo4", LocalDate.of(2025, 02, 01), LocalDate.of(2025, 02, 10), 5);

		System.out.println(t3 + ", " +  t3.isLate());
		System.out.println(t4 + ", " + t4.isLate());

		t3.changeStatus(TaskStatus.FINISHED);
		t4.delay(30);

		System.out.println(t3 + ", " + t3.isLate());
		System.out.println(t4 + ", " + t4.isLate());


	}

}