package tp04;

public class StudentAbs {
    public final static int thresholdAbs = 5;

    private Student etu;
    private int abs;
    
    public StudentAbs(Person person, double[] grades, int abs) {
        this.etu = new Student(person, grades);
        this.abs = abs;
    }

    public StudentAbs(String forename, String name, double[] grades, int abs) {
        this.etu = new Student(forename, name, grades);
        this.abs = abs;
    }

    public StudentAbs(String forename, String name, double grade, int abs) {
        this.etu = new Student(forename, name, grade);
        this.abs = abs;
    }

    public StudentAbs(String forename, String name, double grade) {
        this.etu = new Student(forename, name, grade);
        this.abs = 0;
    }

    public String getName() {
        return this.etu.getName();
    }

    public void setName(String newName) {
        this.etu.setName(newName);
    }

    public String getForename() {
        return this.etu.getForename();
    }

    public void setForename(String newName) {
        this.etu.setForename(newName);
    }

    public int getID() {
        return this.etu.getID();
    }

    public void addGrade(double grade) {
        this.etu.addGrade(grade);
    }

    public double[] getGrades() {
        return this.etu.getGrades();
    }

    public double getAverage() {
        return this.etu.getAverage();
    }

    public int getAbs() {
        return this.abs;
    }

    public void incrAbs() {
        this.abs++;
    }

    public String toString() {
        return "" + this.etu + ", nbAbs=" + this.abs;
    }

    public boolean equals(Object other) {
        if (other == null) {
            return false;
        }
        if (other.getClass() == this.getClass()) {
            StudentAbs otherStudentAbs = (StudentAbs) other;
            double[] thisStudentGrades = this.etu.getGrades();
            boolean arrayEquals = true;
            double[] otherStudentGrades = otherStudentAbs.getGrades();
            if (otherStudentGrades.length == thisStudentGrades.length) {
                for (int i = 0; i < thisStudentGrades.length; i++) {
                    arrayEquals = thisStudentGrades[i] == otherStudentGrades[i];
                }
            }
            return this.getID() == otherStudentAbs.getID() && arrayEquals && this.getAbs() == otherStudentAbs.getAbs();
        }
        return false;
    }

    public boolean warning() {
        return this.abs > StudentAbs.thresholdAbs || this.etu.getAverage() < Student.thresholdAvg;
    }

    public boolean validation() {
        return !this.warning();
    }


}
