package tp04;

import java.util.Arrays;

public class YearGroup {
    private StudentAbs[] yg;

    public YearGroup() {
        this.yg = new StudentAbs[];
    }

    public int getRealLength() {
        int count = 0;
        for (int i = 0; i < this.yg.length; i++) {
            if (this.yg[i] != null) {
                count++;
            }
        }
        return count;
    }

    public void addStudent(StudentAbs student) {
        if (this.yg.length != this.getRealLength()) {
            for (int i = 0; i < this.yg.length; i++) {
                if (this.yg[i] == null) {
                    this.yg[i] = student;
                }
            }
        } else {
            this.yg = Arrays.copyOf(this.yg, this.yg.length + 1);
            this.yg[this.yg.length - 1] = student;
        }
    }

    public void addStudent(StudentAbs[] students) {
        for (int i = 0; i < students.length; i++) {
            this.addStudent(students[i]);
        }
    }

    public void addGrades(double[] grades) {
        for (int i = 0; i < grades.length; i++) {
            this.yg[i].addGrade(grades[i]);
        }
    }

    public void validation() {
        for (int i = 0; i < this.yg.length; i++) {
            if (this.yg[i].validation()) {
                System.out.println(this.yg[i]);
            }
        }
    }
}
